<html>
    <head>
        <title>Three.js Video Test</title>

        <style>
            body {margin: 0;}
            canvas {width: 100%; height: 100%;}
        </style>
    </head>
    
    <body>
        <script src="js/three.js"></script>
        <script src="js/OrbitControls.js"></script>
        <script src="js/THREEx.KeyboardState.js"></script>
        <script>
            var keyboard = new THREEx.KeyboardState();
            var scene = new THREE.Scene();
            var camera = new THREE.PerspectiveCamera(75, window.innerWidth / window.innerHeight, 0.1, 1000);

            var renderer = new THREE.WebGLRenderer();
            renderer.setSize(window.innerWidth, window.innerHeight);
            document.body.appendChild(renderer.domElement);

            window.addEventListener('resize', function(){
                var width = window.innerWidth;
                var height = window.innerHeight;
                renderer.setSize(width, height);
                camera.aspect = width / height;
                camera.updateProjectionMatrix();
            });

            controls = new THREE.OrbitControls(camera, renderer.domElement);

            // VIDEO
            //

            var video1 = document.createElement('video');
            video1.src = 'video/standby.mp4'; 
            video1.load();
            video1.play();

            var texture1 = new THREE.VideoTexture( video1 );
            texture1.minFilter = THREE.LinearFilter;
            texture1.magFilter = THREE.LinearFilter;
            texture1.format = THREE.RGBFormat;

            var movieMaterial1 = new THREE.MeshBasicMaterial( { map: texture1, side: THREE.BackSide } );

            var video2 = document.createElement('video');
            video2.src = 'video/standbyInverted.mov';
            //video2.src = 'video/standby.mp4';
            //video2.src = 'video/test_felipe_inner_full_2.mp4'; 
            video2.load();
            video2.play();

            var texture2 = new THREE.VideoTexture( video2 );
            texture2.minFilter = THREE.LinearFilter;
            texture2.magFilter = THREE.LinearFilter;
            texture2.format = THREE.RGBFormat;

            var movieMaterial2 = new THREE.MeshBasicMaterial( { map: texture2, side: THREE.BackSide, transparent: true } );


            var video3 = document.createElement('video');
            video3.src = 'video/video1.mp4';
            //video2.src = 'video/standby.mp4';
            //video2.src = 'video/test_felipe_inner_full_2.mp4'; 
            video3.load();
            video3.play();

            var texture3 = new THREE.VideoTexture( video3 );
            texture3.minFilter = THREE.LinearFilter;
            texture3.magFilter = THREE.LinearFilter;
            texture3.format = THREE.RGBFormat;

            var movieMaterial3 = new THREE.MeshBasicMaterial( { map: texture3, side: THREE.BackSide, transparent: true } );

            //
            // END OF VIDEO
            //

            var cylinderMaterials = [
                movieMaterial1,
                new THREE.MeshBasicMaterial( { transparent: true, opacity: 0.01, side:THREE.DoubleSide } ),
                new THREE.MeshBasicMaterial( { transparent: true, opacity: 0.01, side:THREE.DoubleSide } )
            ];

            var cylinderMaterials2 = [
                movieMaterial3,
                new THREE.MeshBasicMaterial( { transparent: true, opacity: 0.01, side:THREE.DoubleSide } ),
                new THREE.MeshBasicMaterial( { transparent: true, opacity: 0.01, side:THREE.DoubleSide } )
            ];

           /* var cylinderMaterials = [
                movieMaterial1,
                new THREE.MeshBasicMaterial( { transparent: true, opacity: 0.01, side:THREE.DoubleSide } ),
                movieMaterial2
            ];*/
            var cylinderGeometry = new THREE.CylinderGeometry( 30, 30, 70, 32, 20, false, 0, 2*Math.PI);
            //var cylinderGeometry = new THREE.CylinderGeometry( 30, 30, 70, 32, 20, false, 0, 1.5*Math.PI);
            var cylinder = new THREE.Mesh( cylinderGeometry , cylinderMaterials );
            scene.add( cylinder );

            /*
            var cylinderGeometry2 = new THREE.CylinderGeometry( 30, 30, 10, 32, 20, false, 1.7*Math.PI, 2*Math.PI);
            var cylinder2 = new THREE.Mesh( cylinderGeometry , cylinderMaterials2 );
            cylinder2.rotation.y += 135;
            scene.add( cylinder2 );
            */
            

            var geometry = new THREE.ConeGeometry( 60, -1, 640, 1, true );
            var material = new THREE.MeshBasicMaterial( {color: 0xffff00} );
            var cone = new THREE.Mesh( geometry, new THREE.MeshBasicMaterial( { map: texture2, side: THREE.FrontSide } ));
            scene.add( cone );
            //cone.rotation.x += 165;
            //cone.position.y -= 17.5;
            cone.position.y -= 17.5;
            cylinder.position.y -= 17.5;

            camera.position.z = 25; 
            camera.position.y += 20; 

            //game logic
            var update = function() {
                if ( keyboard.pressed("p") ){
		            video1.play();
                    video2.play();
                    video3.play();
                }     
            };

            //draw scene
            var render = function(){
                renderer.render(scene, camera);
            };

            //run game loop (update, render, repeat)
            var GameLoop = function() {
                requestAnimationFrame(GameLoop);
                update();
                render();
            };

            GameLoop();
        </script>
    </body>
</html>